#ifndef DISK_HPP
#define DISK_HPP

#include <iostream>
#include <map>
#include <string>
#include <cstring>
#include <glibtop.h>
#include <glibtop/mountlist.h>
#include <glibtop/fsusage.h>
#include <sys/utsname.h>

#include <boost/extension/extension.hpp>
#include <boost/extension/factory.hpp>
#include <boost/extension/type_map.hpp>

#include <plugins/plugin.hpp>

#include <ndds/ndds_cpp.h>
#include "disk_dds.h"
#include "disk_ddsSupport.h"


class disk : public plugin {
public:
	disk(DDSDomainParticipant *participant);
	virtual void publish_information(void);
private:
    host_info hi_;
	//DDS Stuff
	DDSDomainParticipant *participant_;
	DDSPublisher *publisher_;
	DDSTopic *topic_;
	DDSDataWriter *writer_;
	filesystemDataWriter * filesystem_writer_;
	filesystem *instance_;
	DDS_ReturnCode_t retcode_;
	DDS_InstanceHandle_t instance_handle_;
	const char *type_name_;
	DDS_Duration_t send_period_;
	std::string qos_file_;
};


BOOST_EXTENSION_TYPE_MAP_FUNCTION
{
	using namespace boost::extensions;
	std::map<std::string, factory<plugin, DDSDomainParticipant *> > &plugin_factories(types.get());
	plugin_factories["disk"].set<disk>();
}

#endif //DISK_HPP


